/*
 * Created on Jun 11, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.GTADS.client;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import org.GTADS.protocol.*;
import org.GTADS.usermanager.TranslateManager;
import org.GTADS.messenger.*;
import org.GTADS.client.swing.*;

import java.io.IOException;

import org.GTADS.client.preferences.PreferencesDialog;
import org.GTADS.client.preferences.PreferencesManager;
import org.GTADS.client.swing.GTADSFrame;
import org.GTADS.helper.*;

/**
 * @author Administrator
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ChatWindowDialog extends GTADSFrame implements ActionListener, KeyListener, MouseListener {
	private TranslateManager locale = TranslateManager.getInstance();
	private GTADSPanel chatPanel = new GTADSPanel();
	private GTADSTabbedPanel tabbedChatFrame = new GTADSTabbedPanel();
	private GTADSPanel chatroom = new GTADSPanel();
	private GTADSScrollPane chatroomScroll = new GTADSScrollPane();
	private GTADSTextArea messageChatBox = new GTADSTextArea();
	private GTADSTextField inputChatBox = new GTADSTextField();
	private GTADSList usersList = new GTADSList();
	private Vector userListVector = new Vector();
	private GTADSButton joinGameButton = new GTADSButton("Join");
	private GTADSButton hostGameButton = new GTADSButton("Host");
	private GTADSButton sendTextButton = new GTADSButton("Send");
	private GTADSScrollPane usersListScroll = new GTADSScrollPane();
	private Hashtable messageBuffer = new Hashtable();
	private String username;
	private DashboardArea dashboard = new DashboardArea();
	
	private GTADSMenuBar gtadsMenuBar = new GTADSMenuBar();
	private GTADSMenu fileMenu;
	private GTADSMenu chatMenu;
	private GTADSMenu aboutMenu;
	private GTADSMenuItem showFriendsList = new GTADSMenuItem("Show FriendsList");
	private GTADSMenuItem editPreferences = new GTADSMenuItem(locale.printLocale("Preferences") + "...");
	private GTADSMenuItem quitProgram = new GTADSMenuItem("Quit");
	private GTADSMenuItem joinChatroom = new GTADSMenuItem(locale.printLocale("Join Chatroom") + "...");
	private GTADSMenuItem quitChatroom = new GTADSMenuItem("Part Chatroom");
	private GTADSMenuItem openChatroomList = new GTADSMenuItem("Get Chatroom List");
	private GTADSMenuItem aboutWindow = new GTADSMenuItem(locale.printLocale("About") + "...");
	private GTADSMenuItem sendIM;
	
	private JLabel chatroomLabel = new JLabel("");
	private static ChatWindowDialog instance;
	String chatroomName = new String(PreferencesManager.getInstance().getDefaultChatroom());
	
	public static ChatWindowDialog getInstance() {
		if (instance instanceof ChatWindowDialog) {
			return instance;
		}
		else {
			return null;
		}	
	}
	
	public static void createInstance(String username) throws IOException{
		instance = new ChatWindowDialog(username);
	}
	
	public static void destroyInstance(){
		PreferencesManager.getInstance().setValue("CHATWINDOWX", instance.getX() + "");
		PreferencesManager.getInstance().setValue("CHATWINDOWY", instance.getY() + "");
		PreferencesManager.getInstance().writeOutPreferences();
		instance.dispose();
		instance = null;
	}
	
	ChatWindowDialog (String username) throws IOException{
		super(TranslateManager.getInstance().printLocale("GTA Multiplayer Client") + ": " + DSChatClient.ClientSocket.getInetAddress() + ":" 
				+ DSChatClient.ClientSocket.getPort());
		this.username = username;
		init();
	}
		
	private void init(){
		chatPanel.setLayout(new BoxLayout(chatPanel, BoxLayout.Y_AXIS));
		this.setResizable(false);
		this.setLocation(PreferencesManager.getInstance().getMainWindowX(),
				PreferencesManager.getInstance().getMainWindowY());
		
		this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		
		tabbedChatFrame.addTab("Main Chat", chatroom);
		setUpChatBoxes();
		setUpMenuItems();
		tabbedChatFrame.setSize(chatPanel.getWidth(), chatPanel.getHeight());
		//usersList = new JList(userListVector);
		usersList.addMouseListener(this);
		
		chatroom.setBackground(Color.darkGray);
		GTADSPanel Panel1 = new GTADSPanel(new FlowLayout(FlowLayout.LEFT));
		GTADSPanel Panel2 = new GTADSPanel(new FlowLayout(FlowLayout.LEFT));
		GTADSPanel Panel3 = new GTADSPanel(new FlowLayout(FlowLayout.LEFT));
		
		Panel2.setAlignmentX(Box.CENTER_ALIGNMENT);
		
		sendTextButton.addActionListener(this);
		messageChatBox.setAutoscrolls(true);
		messageChatBox.setWrapStyleWord(true);
		inputChatBox.setColumns(messageChatBox.getColumns());
		inputChatBox.addKeyListener(this);
		
		Panel1.add(chatroomLabel);
		Panel2.add(tabbedChatFrame);
		Panel2.add(usersListScroll);
		Panel3.add(inputChatBox);
		Panel3.add(Box.createHorizontalStrut(60));
		Panel3.add(sendTextButton);
		
		chatPanel.add(dashboard);
		chatPanel.add(Panel1);
		chatPanel.add(Panel2);
		chatPanel.add(Panel3);
		
		setContentPane(chatPanel);
		this.setJMenuBar(gtadsMenuBar);
		
		this.addWindowListener(new WindowAdapter() {
			public void windowClosed(WindowEvent e){
				try {
					ChatWindowDialog.destroyInstance();
					System.exit(0);
				} catch (Exception E) {}
			}
		});
		
		pack();
		show();
		
		/*
		chatPanel.setLayout(null);
		this.setSize(1000,600);
		if (!DSChatClient.isApplet) {
			this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		}
		
		tabbedChatFrame.addTab("Main Chat", chatroom);
		tabbedChatFrame.setBounds(new Rectangle(160,100,600,300));
		setUpChatBoxes();
		setUpMenuItems();
		usersList = new JList(userListVector);
		usersList.addMouseListener(this);
		usersList.setBounds(new Rectangle (780, 120, 150, 277));
		inputChatBox.setBounds(new Rectangle(163,410,597,20));
		sendTextButton.setBounds(new Rectangle(780,410,150, 20));
		
//		inputChatBox.setLineWrap(false);
		
		sendTextButton.addActionListener(this);
		messageChatBox.setAutoscrolls(true);
		messageChatBox.setWrapStyleWord(true);
		inputChatBox.setColumns(50);
		inputChatBox.addKeyListener(this);
		chatPanel.add(inputChatBox);
		chatPanel.add(sendTextButton);
		chatPanel.add(tabbedChatFrame);
		chatPanel.add(usersList);
		
		this.setJMenuBar(gtadsMenuBar);
		
		if (DSChatClient.isApplet){
			this.addWindowListener(new WindowAdapter() {
				public void windowClosed(WindowEvent e){
					try {
						DSChatClient.ClientSocket.close();
					} catch (IOException ioe) {}
				}
			});
		}
		
		setContentPane(chatPanel);
		show();
		*/
		
		//MetaData joinChatroomHeader = new MetaData(username, MetaData.GENERIC, MetaData.JOIN_CHATOOM);
		//inputChatBox.setText("/join GTADS");
		//processCommand();
		try {
			MessageAdapter.joinChatroom(chatroomName);
			tabbedChatFrame.setTitleAt(0, chatroomName);
		} catch (IOException ioe) {
			DialogManager.ErrorDialog("Could not Join " + chatroomName);
		}
	}
	
	public void appendToChatroom(int msgType, String newText) {
		if (msgType == 0)
			newText = "<System> " + newText + "\n";
		else if (msgType == 1)
			newText = " *" + newText + " has joined chatroom\n";
		else if (msgType == 2)
			newText = " *" + newText + " has left chatroom\n";
		else
			newText += "\n";
		
		if (PreferencesManager.getInstance().getTimeStamps()){
			newText = "[" + Helper.getDate(false) + "] " + newText;
		}
		
		messageChatBox.setText(messageChatBox.getText() + newText);
		int scrollbarValue = chatroomScroll.getVerticalScrollBar().getValue();
		int scrollbarMax = chatroomScroll.getVerticalScrollBar().getMaximum();
		//chatroomScroll.getVerticalScrollBar()
		
		int end = messageChatBox.getText().length();
		messageChatBox.select(end,end);

		messageChatBox.repaint();
	}
	
	private void setUpChatBoxes(){
		messageChatBox.setEditable(false);
		messageChatBox.setLineWrap(true);
		chatroom.setLayout(new FlowLayout());
		chatroomScroll = new GTADSScrollPane(messageChatBox, ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		chatroom.removeAll();
		chatroom.add(chatroomScroll);
		messageChatBox.setRows(20);
		messageChatBox.setColumns(60);
		chatroomScroll.setAutoscrolls(true);
		
		usersListScroll = new GTADSScrollPane(this.usersList, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		usersListScroll.setAutoscrolls(true);
		usersList.setVisibleRowCount(15);
		usersList.setPrototypeCellValue("##################");
	}
	
	private void setUpMenuItems(){
		gtadsMenuBar = new GTADSMenuBar();
		
		fileMenu = new GTADSMenu("File");
		chatMenu = new GTADSMenu("Chat");
		aboutMenu = new GTADSMenu("Help");
		
		showFriendsList = new GTADSMenuItem("Show FriendsList");
		quitProgram = new GTADSMenuItem("Quit");
		sendIM = new GTADSMenuItem(locale.printLocale("Send IM") + "...");
		
		gtadsMenuBar.add(fileMenu);
		gtadsMenuBar.add(chatMenu);
		gtadsMenuBar.add(aboutMenu);
		fileMenu.add(showFriendsList);
		fileMenu.add(editPreferences);
		fileMenu.add(quitProgram);
		chatMenu.add(joinChatroom);
		chatMenu.add(quitChatroom);
		chatMenu.add(openChatroomList);
		chatMenu.add(sendIM);
		aboutMenu.add(aboutWindow);
		
		showFriendsList.addActionListener(this);
		editPreferences.addActionListener(this);
		quitProgram.addActionListener(this);
		joinChatroom.addActionListener(this);
		openChatroomList.addActionListener(this);
		quitChatroom.addActionListener(this);
		sendIM.addActionListener(this);
		aboutWindow.addActionListener(this);
	}
	
	public void addUserToList(String userName){
		if (userListVector.contains(userName))
			return;
		userListVector.add(userName);
		usersList.setListData(userListVector);
	}
	
	public void removeUserFromList(String userName){
		if (userListVector.contains(userName)){
			userListVector.remove(userName);
			usersList.setListData(userListVector);
		}
	}
	
	public void actionPerformed (ActionEvent evt){
		if (evt.getSource() == sendTextButton) {
			sendChatToRoom();
		}
		else if (evt.getSource().equals(showFriendsList)){
			try {
			FriendsListWindow.getInstance().show();
			} catch (IOException ioe) {}
		}
		else if (evt.getSource().equals(editPreferences)){
			PreferencesDialog.getInstance().show();
		}
		else if (evt.getSource().equals(quitProgram)){
			try {
				MessageAdapter.quitServer(chatroomName);
			}catch (IOException ioe){
			}
		}
		else if (evt.getSource().equals(joinChatroom)){
			try {
				String newChatroom = JOptionPane.showInputDialog(this, locale.printLocale("Chatroom Name"), locale.printLocale("Join Chatroom"), 
						JOptionPane.OK_CANCEL_OPTION);
				if (newChatroom != null && newChatroom != ""){
					joinChatroom(newChatroom, chatroomName);
				}
			} catch (IOException ioe){}
		}
		else if (evt.getSource().equals(quitChatroom)){
			try {
				MessageAdapter.partChatroom(chatroomName);
				userListVector.removeAllElements();
				usersList.setListData(userListVector);
				chatroomName = "";
				tabbedChatFrame.setTitleAt(0, "");
			} catch (IOException ioe){}
		}
		else if (evt.getSource().equals(sendIM)){
			String imUser;
			imUser = JOptionPane.showInputDialog(this, locale.printLocale("Username"), locale.printLocale("Send IM"), 
					JOptionPane.OK_CANCEL_OPTION);
			if (imUser != null && imUser != ""){
				InstantMessageWindow.getInstance(imUser);
			}
		}
		else if (evt.getSource().equals(openChatroomList)){
			ChatroomListingWindow.getInstance().show();
		}
		else if (evt.getSource().equals(aboutWindow)){
			DialogManager.SuccessDialog("GTADS " + DSChatClient.VERSION_NAME + " " + DSChatClient.VERSION_NUMBER + " By\n" +
					"Steven Day\n\n" + "Website: http://gtads.blogspot.com\n");
		}
	}
	
	public void keyPressed (KeyEvent key){
		if (key.getKeyCode() == KeyEvent.VK_ENTER){
			sendChatToRoom();
		}
		else if (inputChatBox.getText().length() >= 255){
			key.setKeyCode(0);
			inputChatBox.setText(inputChatBox.getText().substring(0,254));
		}
	}
	
	public void keyTyped(KeyEvent key){}
	public void keyReleased(KeyEvent key){}
	
	private void sendChatToRoom(){
		if (processCommand() == true)
			return;
		MetaData sendHeader = new MetaData(username, MetaData.CHATROOM, chatroomName);
		try {
			String newChatMessage = inputChatBox.getText();
			if (newChatMessage.length() > 255){
				newChatMessage = newChatMessage.substring(0,254);
			}
			ClientListenHandler.sendChatMessage(sendHeader, newChatMessage);
			inputChatBox.setText("");
			inputChatBox.requestFocus();
		} catch (IOException ioe){
			return;
		}
	}
	
	private boolean isCommandClearScreen(String command){
		boolean isClearScreen = false;
		String CLEAR_SCREEN = "clear";
		
		if (command.length() >= 1 + CLEAR_SCREEN.length() && command.substring(1,1 + CLEAR_SCREEN.length()).equalsIgnoreCase(CLEAR_SCREEN)){
			isClearScreen = true;
		}
		return isClearScreen;
	}
	
	private boolean processCommand(){
		String JOIN_COMMAND = "Join";
		String PART_COMMAND = "Part";
		String QUIT_COMMAND = "Quit";
		String S_KICK_COMMAND = "skick";
		String UPTIME_COMMAND = "uptime";
		String REFRESH_MOTD = "rmotd";
		String READ_MOTD = "motd";
		String SET_CONFIG = "setconfig";
		String SHOW_CONFIG = "showconfig";
		String SET_BAN_USER = "banuser";
		String REMOVE_BAN_USER = "unbanuser";
		String SET_BAN_IP = "banip";
		String REMOVE_BAN_IP = "unbanip";
		String GET_PING = "pingtime";
		
		String newChatroom = new String();
		String userToKick = new String();
		String command = inputChatBox.getText();
		
		if (command.startsWith("/")){
			inputChatBox.setText("");
			inputChatBox.requestFocus();
			if (command.length() >= 1 + JOIN_COMMAND.length() && command.substring(1,1 + JOIN_COMMAND.length()).equalsIgnoreCase(JOIN_COMMAND)){
				newChatroom = command.substring(("/" + JOIN_COMMAND).length() + 1, command.length());
				try {
					joinChatroom(newChatroom, chatroomName);
				} catch (IOException ioe) {
					DialogManager.ErrorDialog("Could not Join " + newChatroom);
				}
				return true;
			}
			
			else if (command.length() >= 1 + PART_COMMAND.length() && command.substring(1,1 + PART_COMMAND.length()).equalsIgnoreCase(PART_COMMAND)){
				try {
					MessageAdapter.partChatroom(chatroomName);
					userListVector.removeAllElements();
					usersList.setListData(userListVector);
					chatroomName = "";
					tabbedChatFrame.setTitleAt(0, "");
				} catch (IOException ioe) {
					DialogManager.ErrorDialog("Could not Part " + chatroomName);
				}
				return true;
			}
			else if (command.length() >= 1 + QUIT_COMMAND.length() && command.substring(1,1 + QUIT_COMMAND.length()).equalsIgnoreCase(QUIT_COMMAND)) {
				//newChatroom = command.substring(("/" + PART_COMMAND).length(), command.length());
				try {
					MessageAdapter.quitServer(chatroomName);
					chatroomName = "";
				} catch (IOException ioe) {
				}
				return true;
			}
			
			else if (command.length() >= 1 + S_KICK_COMMAND.length() && command.substring(1,1 + S_KICK_COMMAND.length()).equalsIgnoreCase(S_KICK_COMMAND)){
				userToKick = command.substring(("/" + S_KICK_COMMAND).length() + 1, command.length());
				try {
					MessageAdapter.serverKickUser(userToKick);
				} catch (IOException ioe){}
			}
			
			else if (command.length() >= 1 + UPTIME_COMMAND.length() && command.substring(1,1 + UPTIME_COMMAND.length()).equalsIgnoreCase(UPTIME_COMMAND)){
				if (command.length() <= ("/" + UPTIME_COMMAND).length()){
					getUptime(MetaData.SYSTEM_VAR);
				}
				else if (command.length() >= ("/" + UPTIME_COMMAND).length() + 1){
					String userUptime = command.substring(("/" + UPTIME_COMMAND).length() + 1, command.length());
					getUptime(userUptime);
				}
				return true;
			}
			// Admin Command: refresh Motd
			else if (command.length() >= 1 + REFRESH_MOTD.length() && command.substring(1,1 + REFRESH_MOTD.length()).equalsIgnoreCase(REFRESH_MOTD)){
				try {
					MetaData motdRefreshHeader = new MetaData(username, MetaData.GENERIC, MetaData.REFRESH_MOTD);
					MessageAdapter.sendData(null,DSChatClient.ClientSocket,motdRefreshHeader,"NULL");
				} catch (IOException ioe){
					// do nothing
				}
			}
			else if (command.length() >= 1 + READ_MOTD.length() && command.substring(1,1 + READ_MOTD.length()).equalsIgnoreCase(READ_MOTD)){
				try {
					MetaData motdGetHeader = new MetaData(username, MetaData.GENERIC, MetaData.GET_MOTD);
					MessageAdapter.sendData(null,DSChatClient.ClientSocket,motdGetHeader,"NULL");
				} catch (IOException ioe){
					
				}
				return true;
			}
			else if (command.length() >= 1 + SET_CONFIG.length() && command.substring(1,1 + SET_CONFIG.length()).equalsIgnoreCase(SET_CONFIG)){
				if (command.length() >= ("/" + SET_CONFIG).length() + 1){
					String[] keyValue = new String[2];
					String configParameters = command.substring(("/" + SET_CONFIG).length() + 1, command.length());
					if (configParameters != null){
						keyValue = configParameters.split(",");
						if (keyValue.length > 1){
							MetaData requestConfigChangeHeader = new MetaData(
									username, MetaData.GENERIC,MetaData.SET_CONFIG);
							try {
							MessageAdapter.sendData(null,DSChatClient.ClientSocket,
									requestConfigChangeHeader,keyValue[0] + "," + keyValue[1]);
							} catch (IOException ioe){
							}
						}
						else {
							this.appendToChatroom(0, "Invalid parameters:");
							this.appendToChatroom(0, "Correct Use: /setconfig key,value");
						}
					}
				}
				return true;
			}
			else if (command.length() >= 1 + SHOW_CONFIG.length() && command.substring(1,1 + SHOW_CONFIG.length()).equalsIgnoreCase(SHOW_CONFIG)){
				try {
					MetaData displayConfigOptions = new MetaData(
							username, MetaData.GENERIC,MetaData.SET_CONFIG);
					MessageAdapter.sendData(null,DSChatClient.ClientSocket,displayConfigOptions,MetaData.SHOW_CONFIG);
				} catch (IOException ioe){
					
				}
				return true;
			}
			else if (command.length() >= 1 + SET_BAN_USER.length() && command.substring(1,1 + SET_BAN_USER.length()).equalsIgnoreCase(SET_BAN_USER)){
				String argString = command.substring(("/" + SET_BAN_USER).length() + 1, command.length());
				String[] banned = argString.split(",");
				String duration = "";
				if (banned.length > 1){
					duration = banned[1];
				}
				MetaData banUserHeader = new MetaData(username, MetaData.GENERIC,MetaData.BAN_USER);
				try {
				MessageAdapter.sendData(null,DSChatClient.ClientSocket,banUserHeader,banned[0] + "," + duration);
				} catch (IOException ioe){
				}
			}
			else if (command.length() >= 1 + REMOVE_BAN_USER.length() && command.substring(1,1 + REMOVE_BAN_USER.length()).equalsIgnoreCase(REMOVE_BAN_USER)){
				String banned = command.substring(("/" + REMOVE_BAN_USER).length() + 1, command.length());
				
				MetaData banUserHeader = new MetaData(username, MetaData.GENERIC,MetaData.UNBAN_USER);
				try {
				MessageAdapter.sendData(null,DSChatClient.ClientSocket,banUserHeader,banned);
				} catch (IOException ioe){
				}
			}
			else if (command.length() >= 1 + SET_BAN_IP.length() && command.substring(1,1 + SET_BAN_IP.length()).equalsIgnoreCase(SET_BAN_IP)){
				String argString = command.substring(("/" + SET_BAN_IP).length() + 1, command.length());
				String[] banned = argString.split(",");
				String duration = "";
				if (banned.length > 1){
					duration = banned[1];
				}
				MetaData banUserHeader = new MetaData(username, MetaData.GENERIC,MetaData.BAN_IP);
				try {
				MessageAdapter.sendData(null,DSChatClient.ClientSocket,banUserHeader,banned[0] + "," + duration);
				} catch (IOException ioe){
				}
			}
			else if (command.length() >= 1 + REMOVE_BAN_IP.length() && command.substring(1,1 + REMOVE_BAN_IP.length()).equalsIgnoreCase(REMOVE_BAN_IP)){
				String banned = command.substring(("/" + REMOVE_BAN_IP).length() + 1, command.length());
				MetaData banUserHeader = new MetaData(username, MetaData.GENERIC,MetaData.UNBAN_IP);
				try {
				MessageAdapter.sendData(null,DSChatClient.ClientSocket,banUserHeader,banned);
				} catch (IOException ioe){
				}
			}
			else if (command.length() >= 1 + GET_PING.length() && command.substring(1,1 + GET_PING.length()).equalsIgnoreCase(GET_PING)){
				String userName = command.substring(("/" + GET_PING).length() + 1, command.length());
				try {
				if (userName != null){
					MetaData getPingTimeHeader = new MetaData(username, MetaData.GENERIC,MetaData.GET_PING);
					MessageAdapter.sendData(null,DSChatClient.ClientSocket,getPingTimeHeader,userName);
				}
				} catch (IOException ioe){
				}
				
			}
			else if (isCommandClearScreen(command)){
				messageChatBox.setText(new String());
			}
		}
		return false;
	}

	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
	 */
	public void mouseClicked(MouseEvent e) {
		if (e.getSource() == usersList){
			if (e.getClickCount() == 2){
				InstantMessageWindow.getInstance((String)usersList.getSelectedValue()).show();
			}
		}

	}
	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseEntered(java.awt.event.MouseEvent)
	 */
	public void mouseEntered(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}
	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseExited(java.awt.event.MouseEvent)
	 */
	public void mouseExited(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}
	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mousePressed(java.awt.event.MouseEvent)
	 */
	public void mousePressed(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}
	/* (non-Javadoc)
	 * @see java.awt.event.MouseListener#mouseReleased(java.awt.event.MouseEvent)
	 */
	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub

	}
	
	public void getUptime(String user){
		MetaData requestUptimeHeader;
		try {
			if (user == null){
				user = MetaData.SYSTEM_VAR;
			}
			requestUptimeHeader = new MetaData(this.username, MetaData.GENERIC, MetaData.UPTIME);
			MessageAdapter.sendData(null,DSChatClient.ClientSocket,requestUptimeHeader,user);
		} catch (IOException ioe) {}
	}
	
	public void joinChatroom(String newChatroom, String oldChatroom) throws IOException{
		MessageAdapter.partChatroom(oldChatroom);
		userListVector.removeAllElements();
		usersList.setListData(userListVector);
		chatroomName = newChatroom;
		MessageAdapter.joinChatroom(newChatroom);
		chatroomName = newChatroom;
		tabbedChatFrame.setTitleAt(0, chatroomName);
	}
	
	public DashboardArea getDashboardPanel(){
		return dashboard;
	}
}
