/*
 * Created on May 30, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.GTADS.server;

import java.net.*;
import java.io.*;

import org.GTADS.server.PeriodicClientPing.UserPing;
import org.GTADS.usermanager.*;
import org.GTADS.messenger.*;
import org.GTADS.protocol.*;
import org.GTADS.debug.*;
import org.GTADS.helper.*;
import java.util.*;

/**
 * @author Administrator
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SessionHandler{
	Socket clientInstance;
	DSChatServer thisServer;
	
	public SessionHandler(Socket clientInstance) throws IOException{
		this.clientInstance = clientInstance;
		try {
			init();
		} catch (SocketException se) {
			ServerLogger.sendConsoleDebugMessage("Software caused connection abort of " 
					+ clientInstance.getRemoteSocketAddress(), this.getClass(), 3);
		}
	}
	
	private void init() throws IOException, SocketException{
		// Login Sequence
		String userName;
		String dataIn;
		User currentUser;
		int loginSuccess; 
		
		MetaData loginHeader = new MetaData(MetaData.FROM_SERVER, MetaData.GENERIC, MetaData.LOGIN_SESSION);
		loginSuccess = AuthenticationManager.requestAuthentication(clientInstance, thisServer);
		if (loginSuccess == AuthenticationManager.LOGIN_SUCCESS){
			userName = new String((String)ServerCacheHandler.socketUserCache.get(clientInstance));
			currentUser = new User(userName);
			MessageAdapter.sendData(currentUser,clientInstance, loginHeader, ProtocolHandler.LOGIN_SUCCESS);
			ServerLogger.sendConsoleDebugMessage("User " + userName + " has logged in on " +
					clientInstance.getRemoteSocketAddress(), this.getClass(), 4);
		}
		else if (loginSuccess == AuthenticationManager.MAXED_OUT){
			MessageAdapter.sendData(null, clientInstance, loginHeader, ProtocolHandler.MAXED_USERS);
			ServerLogger.sendConsoleDebugMessage("Users maxed out: " + clientInstance.getRemoteSocketAddress().toString()
					+ " unable to connect "
				 	, this.getClass(), 4);
			return;
		}
		// TODO: Handle new users
		else if (loginSuccess == AuthenticationManager.NEW_USER_SUCCESS){
			MetaData newUserSuccess = new MetaData(MetaData.FROM_SERVER, MetaData.GENERIC, MetaData.LOGIN_SESSION);
			MessageAdapter.sendData(null, clientInstance, newUserSuccess, ProtocolHandler.LOGIN_SUCCESS);
			ServerLogger.sendConsoleDebugMessage("New user created", this.getClass(), 5);
			return;
		}
		else if (loginSuccess == AuthenticationManager.NEW_USER_DISABLED){
			MetaData newUserFail = new MetaData(MetaData.FROM_SERVER, MetaData.GENERIC, MetaData.NEW_USER_ACCT);
			MessageAdapter.sendData(null, clientInstance, newUserFail, "DISABLED");
			return;
		}
		else if (loginSuccess == AuthenticationManager.NEW_USER_FAIL){
			MetaData newUserFail = new MetaData(MetaData.FROM_SERVER, MetaData.GENERIC, MetaData.NEW_USER_ACCT);
			MessageAdapter.sendData(null, clientInstance, newUserFail, ProtocolHandler.LOGIN_FAIL);
			return;
		}
		else if (loginSuccess == AuthenticationManager.USER_BANNED){
			MessageAdapter.sendData(null, clientInstance, loginHeader, MetaData.USER_BANNED);
			ServerLogger.sendConsoleDebugMessage("User is banned from server!", this.getClass(), 4);
			return;
		}
		else {
			MessageAdapter.sendData(null, clientInstance, loginHeader, ProtocolHandler.LOGIN_FAIL);
			ServerLogger.sendConsoleDebugMessage("Failed Login Attempt for " + clientInstance.getRemoteSocketAddress().toString()
				 	, this.getClass(), 4);
			return;
		}
		
		// Check if proxy port is open not compatible with Beta Release 1.0
		if (!checkProxyPortOpen(clientInstance)){
			MetaData proxyFailed = new MetaData(MetaData.FROM_SERVER, MetaData.GENERIC, MetaData.PROXY_CHECK);
			MessageAdapter.sendData(null, clientInstance,proxyFailed,MetaData.PROXY_FAIL);
			ServerLogger.sendConsoleDebugMessage("User's Proxy port closed or old client version", this.getClass(), 4);
			ServerCacheHandler.userProxyPortState.put(userName,new Boolean(false));
		}
		else {
			ServerCacheHandler.userProxyPortState.put(userName,new Boolean(true));
		}
		
		Date d = new Date(); // Set uptime for user
		Long uptime = new Long(d.getTime());
		ServerCacheHandler.userUptimeCache.put(userName, uptime);
		
		FriendsListManager.getInstance().announceFriendsSignOn(userName);
		
		MetaData motdHeader = new MetaData(MetaData.FROM_SERVER, MetaData.CHATROOM, MetaData.NO_SESSION_NAME);
		displayMotd(motdHeader,currentUser);
		
		DataInputStream din = new DataInputStream(clientInstance.getInputStream());
		int i = 0;
		try {
			do {
				dataIn = din.readUTF();
				i++;
				
				if (i >= 100){
					i = 0;
					checkUserLimit((String)ServerCacheHandler.socketUserCache.get(clientInstance));
				}
				
				if (dataIn != null) {
					handleDataInput(dataIn, currentUser);
				}
				
			} while (dataIn != null);
		} catch (IOException ioe) {
			if (currentUser.getChatroom() == null || currentUser.getChatroom().isEmpty())
				throw ioe;
			else {
				//for (int i = 0; i<currentUser.getChatroom().size(); i++){
				//	((Chatroom)ServerCacheHandler.chatroomNameCache.
				//			get(currentUser.getChatroom().get(i))).removeUserFromChatroom(currentUser.getUsername());
					// Send message to chatroom notifying everyone
					// That currentUser is off the list
					// TODO figure out where to clean up empty chatrooms
					// Perhaps PeriodicStatusChecker or another timer based
					// server thread
				//}
			}
		}
		catch (NullPointerException npe){
			npe.printStackTrace();
			throw new IOException();
		}
	}
	
	private boolean checkProxyPortOpen(Socket clientSocket) throws IOException {
		boolean isOpenProxy = false;
		String incomingString = new String();
		String proxyPort = new String();
		
		MetaData requestProxyCheckHeader = new MetaData(MetaData.FROM_SERVER, MetaData.GENERIC, MetaData.PROXY_CHECK);
		MessageAdapter.sendData(null,clientSocket,requestProxyCheckHeader,"NULL");
		
		clientSocket.setSoTimeout(10000);

		// Wait 10 seconds 
		try {
		DataInputStream din = new DataInputStream(clientSocket.getInputStream());
		incomingString = din.readLine();
		
		if (incomingString != null)	{
			if (incomingString.split(",").length >= 4){
				proxyPort = incomingString.split(",")[3];
				
				Integer proxyPortInt = Integer.valueOf(proxyPort);
				
				byte[] b = new byte[1];
				b[0] = 1;
				DatagramSocket checkSocket = new DatagramSocket();
				DatagramPacket checkPacket = new DatagramPacket(b,1,clientSocket.getInetAddress(),
						proxyPortInt.intValue());
				checkSocket.send(checkPacket);
				
				incomingString = din.readLine();
				
				if (incomingString.split(",").length >= 4){
					if (incomingString.split(",")[3].equalsIgnoreCase(MetaData.PROXY_SUCCESS)){
						isOpenProxy = true;
					}
				}
				checkSocket.close();
				clientSocket.setSoTimeout(0);
			}
		}
		
		} catch (InterruptedIOException ioe){
			clientSocket.setSoTimeout(0);
		} catch (NumberFormatException nfe){
			clientSocket.setSoTimeout(0);
		}
		return isOpenProxy;
	}
	
	private static boolean checkProxyPortOpen(Socket clientSocket, String proxyPort) throws IOException {
		boolean isOpenProxy = false;
		String incomingString = new String();
		
		MetaData requestProxyCheckHeader = new MetaData(MetaData.FROM_SERVER, MetaData.GENERIC, MetaData.PROXY_CHECK);
		MessageAdapter.sendData(null,clientSocket,requestProxyCheckHeader,"NULL");
		

		// Wait 10 seconds 
		try {
			
			if (incomingString != null)	{				
				Integer proxyPortInt = Integer.valueOf(proxyPort);
				
				byte[] b = new byte[1];
				b[0] = 1;
				DatagramSocket checkSocket = new DatagramSocket();
				DatagramPacket checkPacket = new DatagramPacket(b,1,clientSocket.getInetAddress(),
						proxyPortInt.intValue());
				checkSocket.send(checkPacket);
				checkSocket.close();
			}		
		} catch (InterruptedIOException ioe){
			clientSocket.setSoTimeout(0);
		} catch (NumberFormatException nfe){
			clientSocket.setSoTimeout(0);
		}
		return isOpenProxy;
	}

	
	private void displayMotd(MetaData md, User u) throws IOException{
		String motd[];;
		int count, lines;
		
		if (ServerConfig.getInstance().getMotd() != null) {
			lines = ServerConfig.getInstance().getMotd().split("\r\n").length;
			motd = new String[lines];
			motd = ServerConfig.getInstance().getMotd().split("\r\n");
		}
		else
			return;
		
		for (count = 0; count < motd.length; count++)
			MessageAdapter.sendData(u.getUsername(),clientInstance,md, motd[count]);
	}
	
	public void handleDataInput(String dataIn, User currentUser) throws IOException {
		dataIn = Helper.clipCarriageReturn(dataIn);
		String recipient = ProtocolHandler.getDataFromMessage(dataIn,ProtocolHandler.RECIPIENT);
		String context = ProtocolHandler.getDataFromMessage(dataIn,ProtocolHandler.CONTEXT);
		String session = ProtocolHandler.getDataFromMessage(dataIn,ProtocolHandler.SESSION);
		String message = ProtocolHandler.getDataFromMessage(dataIn,ProtocolHandler.MESSAGE);
		
		// TODO: May have to modify this for Clustering between servers
		// Probably won't happen for a while
		if (recipient != null && ServerCacheHandler.userSocketCache.containsKey(recipient)
				&& recipient.equals(currentUser.getUsername())){
			if (context != null && context.equalsIgnoreCase(MetaData.GENERIC + "")){
				// None chat general requests
				if (session != null && session.equalsIgnoreCase(MetaData.JOIN_CHATROOM)){
					// Request to Join a Chatroom
					if (message != null){
						if (Chatroom.isCorrectChatroomName(message)){
							// Check if Maximum Chatrooms are reached on Server
							if (ServerCacheHandler.chatroomNameCache.containsKey(message)){
								// If the room exists already add the user
								// but don't create a new room in the Server Cache
								if (((Chatroom)ServerCacheHandler.chatroomNameCache.get(message)).hasUser(currentUser.getUsername())){
									// If user already exists in the chatroom do nothing.
									return;
								}
								else {
									// Check if chatroom is not full
									if (ServerConfig.getInstance().getMaxInChatrooms() > 0){
										int userCount = ((Chatroom)ServerCacheHandler.chatroomNameCache.get(message)).getListOfUsers().size();
										if (userCount >= ServerConfig.getInstance().getMaxInChatrooms() &&
												!currentUser.getUsername().equalsIgnoreCase(ServerConfig.getInstance().getAdminAccount())){
											ErrorManager.sendErrorToClient(clientInstance, ErrorManager.CHATROOM_FULL);
											return;
										}
									}
									((Chatroom)ServerCacheHandler.chatroomNameCache.get(message)).addUserToChatroom(currentUser.getUsername());
									Vector v = new Vector();
									if (ServerCacheHandler.userChatroomCache.containsKey(currentUser.getUsername())){
										v = (Vector)ServerCacheHandler.userChatroomCache.get(currentUser.getUsername());
									}
									else {
										v = new Vector();
									}
									v.add(message);
									ServerCacheHandler.userChatroomCache.put(currentUser.getUsername(), v);
									// Send a list of users in the current chatroom.
									Chatroom joinedRoom = (Chatroom)ServerCacheHandler.chatroomNameCache.get(message);
									// Announce Users arrival and get list of users
									announceUserJoin(joinedRoom, currentUser);
									sendInitialChatroomUserList(joinedRoom, currentUser);
									welcomeUserToChatroom(joinedRoom.getChatroomName());
								}
							}
							else {
								// Check Access Rights on Joining
								// Add user to room vector
								if (ServerConfig.getInstance().getMaxChatrooms() > 0){
									int currentChatCount = ServerCacheHandler.chatroomNameCache.size();
									if (currentChatCount >= ServerConfig.getInstance().getMaxChatrooms()){
										ErrorManager.sendErrorToClient(clientInstance, ErrorManager.CHATROOM_MAX);
										return;
									}
								}
								ServerLogger.sendConsoleDebugMessage("User " + recipient + " is creating chatroom " + message,
										this.getClass(), 5);
								Chatroom thisChatroom = new Chatroom(currentUser, message);
								ServerCacheHandler.chatroomNameCache.put(message, thisChatroom);
								Vector v = new Vector();
								if (ServerCacheHandler.userChatroomCache.containsKey(currentUser.getUsername())){
									v = (Vector)ServerCacheHandler.userChatroomCache.get(currentUser.getUsername());
								}
								else {
									v = new Vector();
								}
								v.add(message);
								ServerCacheHandler.userChatroomCache.put(currentUser.getUsername(), v);
								//ServerCacheHandler.userChatroomCache.put(currentUser.getUsername(), message);
								welcomeUserToChatroom(thisChatroom.getChatroomName());
							}
						}
						else {
							MetaData errorChatroomHeader = new MetaData(MetaData.FROM_SERVER, MetaData.CHATROOM, MetaData.NO_SESSION_NAME);
							MessageAdapter.sendData(null, clientInstance, errorChatroomHeader,message + ": Illegal chatroom name");
							// SERVER,1,NONE
						}
					}
				}
				else if (session != null && session.equalsIgnoreCase(MetaData.PING_REPLY)){
					UserPing b = (UserPing)ServerCacheHandler.userPingTimeCache.get(currentUser.getUsername());
					if (b != null){
						Date d = new Date();
						b.setInterval(new Long(d.getTime()));
					}
				}
				else if (session != null && session.equalsIgnoreCase(MetaData.GET_PING)){
					if (message != null){
						String pingTime = "-";
						String pingString = "User ping time is ";
						if (ServerCacheHandler.userSocketCache.containsKey(message)){
							if (ServerCacheHandler.userPingTimeCache.containsKey(message)){
								UserPing requestedPing = (UserPing)ServerCacheHandler.userPingTimeCache.get(message);
								if (requestedPing.getPingTime() != null){
									pingTime = requestedPing.getPingTime() + "";
								}
							}
							MetaData pingTimeHeader = new MetaData(MetaData.FROM_SERVER,MetaData.CHATROOM, MetaData.NO_SESSION_NAME);
							MessageAdapter.sendData(null,clientInstance,pingTimeHeader,pingString + pingTime + "ms");
						}
					}
				}
				else if (session != null && session.equalsIgnoreCase(MetaData.PART_CHATROOM)){
					// Check if user is in a chatroom
					
					if (ServerCacheHandler.userChatroomCache.get(currentUser.getUsername()) != null &&
							!((Vector)ServerCacheHandler.userChatroomCache.get(currentUser.getUsername())).isEmpty()){
						Vector v = (Vector)ServerCacheHandler.userChatroomCache.get(currentUser.getUsername());
						for (int i = 0; i < v.size(); i++){
							String currentChatName = (String)v.get(i);
							Chatroom currentChat = (Chatroom)ServerCacheHandler.chatroomNameCache.get(currentChatName);
							//ServerCacheHandler.userChatroomCache.remove(currentUser.getChatroom());
							v.remove(i);
							if (currentChat != null){
								currentChat.removeUserFromChatroom(currentUser.getUsername());
								MetaData partRoomHeader = new MetaData (currentChat.getChatroomName(),MetaData.CHATROOM, MetaData.PART_CHATROOM);
								sendChatMessage(partRoomHeader, currentChat,currentUser.getUsername());
								
								if (currentChat.getListOfUsers().isEmpty()){
									ServerCacheHandler.chatroomNameCache.remove(currentChatName);
									ServerLogger.sendConsoleDebugMessage("Chatroom " + currentChatName + " being destroyed (Chatroom Empty)"
											,this.getClass(), 5);
								}
							}
						}	
					}
				}
				else if (session != null && session.equalsIgnoreCase(MetaData.S_KICK)){
					// TODO: Load in Admin values from accounts file
					// For now we will use the admin account
					
					if (currentUser.getUsername().equals(ServerConfig.getInstance().getAdminAccount())){
						if (message != null && ServerCacheHandler.userSocketCache.containsKey(message)){
							DSChatServer.getInstance().serverKick((Socket)ServerCacheHandler.userSocketCache.get(message));
							MetaData informKickedUser = new MetaData(MetaData.FROM_SERVER, MetaData.CHATROOM, MetaData.NO_SESSION_NAME);
							MessageAdapter.sendData(null, (Socket)ServerCacheHandler.userSocketCache.get(message), informKickedUser, 
									"You have been kicked by " + currentUser.getUsername());
							ServerLogger.sendConsoleDebugMessage("User " + message + " kicked off server", this.getClass(), 5);
						}
						else {
							//MetaData noUserFound = new MetaData(MetaData.FROM_SERVER, MetaData.CHATROOM, MetaData.NO_SESSION_NAME);
							//MessageAdapter.sendData(null, clientInstance, noUserFound,"User Not Found");
							ErrorManager.sendErrorToClient(clientInstance, ErrorManager.USER_NOT_FOUND);
						}
					}
					else {
						//MetaData accessDenied = new MetaData(MetaData.FROM_SERVER, MetaData.CHATROOM, MetaData.NO_SESSION_NAME);
						//MessageAdapter.sendData(null, clientInstance, accessDenied,"Access Denied");
						ErrorManager.sendErrorToClient(clientInstance, ErrorManager.ACCESS_DENIED);
					}
				}
				
				else if (session != null && session.equalsIgnoreCase(MetaData.QUIT_CHATROOM)){
					//DSChatServer.getInstance().killConnection(clientInstance, null);
					clientInstance.close();
				}
				
				else if (session != null && session.equalsIgnoreCase(MetaData.UPTIME)){
					if (message != null)
						sendUptimeRequest(message);
				}
				
				else if (session != null && session.equalsIgnoreCase(MetaData.SEND_CHATROOM_LIST)){
					// Disregard message attribute assume NULL
					sendChatroomListings();
				}
				
				else if (session != null && session.equalsIgnoreCase(MetaData.REFRESH_MOTD)){
					// Only do this if user is admin or error
					if (currentUser.getUsername().equals(ServerConfig.getInstance().getAdminAccount())){
						ServerConfig.getInstance().readinMotd();
						MetaData readInOk = new MetaData(MetaData.FROM_SERVER, MetaData.CHATROOM, MetaData.NO_SESSION_NAME);
						MessageAdapter.sendData(null, clientInstance, readInOk, "motd refresh: Ok");
					}
					else {
						ErrorManager.sendErrorToClient(clientInstance,ErrorManager.ACCESS_DENIED);
					}
				}
				
				else if (session != null && session.equalsIgnoreCase(MetaData.GET_MOTD)){
					MetaData motdHeader = new MetaData(MetaData.FROM_SERVER, MetaData.CHATROOM, MetaData.NO_SESSION_NAME);
					this.displayMotd(motdHeader,currentUser);
				}
				
				else if (session != null && session.equalsIgnoreCase(MetaData.SET_CONFIG)){
					if (AuthenticationManager.isAdminAccount(currentUser.getUsername())){						
						if (message.equalsIgnoreCase(MetaData.SHOW_CONFIG)){
							// Display Commands
							ServerConfig.getInstance().displayConfigValues(clientInstance);
						}
						else {
							String[] keyValues = ServerConfig.getInstance().getGenericValues(message);
							if (keyValues != null){
								ServerConfig.getInstance().setGenericValues(keyValues[0], keyValues[1],clientInstance);
							}
						}
					}
					else {
						ErrorManager.sendErrorToClient(clientInstance,ErrorManager.ACCESS_DENIED);
					}
				}
				else if (session != null && session.equalsIgnoreCase(MetaData.CREATE_GAMEROOM)){
					if (ServerCacheHandler.userProxyPortState.get(currentUser.getUsername()).equals(new Boolean(true)))
						GameroomManager.getInstance().createGameroom(currentUser.getUsername(), message);
					else
						ErrorManager.sendErrorToClient(clientInstance, ErrorManager.GAMEROOM_DENIED);
				}
				else if (session != null && session.equalsIgnoreCase(MetaData.BAN_IP)){
					if (message != null){
						String[] argString = message.split(",");
						Long duration = new Long(0);
						
						if (argString.length > 1){
							try {
							duration = Long.valueOf(argString[1]);
							} catch (NumberFormatException nfe){
								duration = new Long(0);
							}
						}
						if (currentUser.getUsername().equals(ServerConfig.getInstance().getAdminAccount())){
							BanManagement.getInstance().setBan(argString[0],true,new Long(duration.longValue() * 1000));
							ServerLogger.sendConsoleDebugMessage("Banning IP Address: " + argString[0] +
									(duration.longValue() == 0 ? " indefinitely" : " for duration of " + (duration.longValue()) +
									" seconds"), this.getClass(), 5);
							MetaData banOK = new MetaData(MetaData.FROM_SERVER, MetaData.CHATROOM, MetaData.NO_SESSION_NAME);
							MessageAdapter.sendData(null, clientInstance, banOK, "IP Address " + argString[0] + " has been banned");
						}
						else {
							ErrorManager.sendErrorToClient(clientInstance,ErrorManager.ACCESS_DENIED);
						}
					}
				}
				else if (session != null && session.equalsIgnoreCase(MetaData.UNBAN_IP)){
					if (message != null){
						String freedIP = message;
						if (currentUser.getUsername().equals(ServerConfig.getInstance().getAdminAccount())){
							BanManagement.getInstance().removeBan(message,true);
							ServerLogger.sendConsoleDebugMessage("Unbanning IP Address: " + message, this.getClass(), 5);
							MetaData unbanOK = new MetaData(MetaData.FROM_SERVER, MetaData.CHATROOM, MetaData.NO_SESSION_NAME);
							MessageAdapter.sendData(null, clientInstance, unbanOK, "IP Address " + message + " has been unbanned");
						}
						else {
							ErrorManager.sendErrorToClient(clientInstance,ErrorManager.ACCESS_DENIED);
						}
					}
				}
				else if (session != null && session.equalsIgnoreCase(MetaData.BAN_USER)){
					if (message != null){
						String[] argString = message.split(",");
						Long duration = new Long(0);
						
						if (argString.length > 1){
							try {
								duration = Long.valueOf(argString[1]);
							} catch (NumberFormatException nfe){
								duration = new Long(0);
							}
						}
						if (currentUser.getUsername().equals(ServerConfig.getInstance().getAdminAccount())){
							if (BanManagement.getInstance().setBan(argString[0],false,new Long(duration.longValue() * 1000))){
								ServerLogger.sendConsoleDebugMessage("Banning username: " + argString[0] +
										(duration.longValue() == 0 ? " indefinitely" : " for duration of " + (duration.longValue()) +
										" seconds"), this.getClass(), 5);
								MetaData banOK = new MetaData(MetaData.FROM_SERVER, MetaData.CHATROOM, MetaData.NO_SESSION_NAME);
								MessageAdapter.sendData(null, clientInstance, banOK, "Username " + argString[0] + " has been banned");
							}
							else {
								ErrorManager.sendErrorToClient(clientInstance, ErrorManager.USER_NOT_FOUND);
							}
						}
						else {
							ErrorManager.sendErrorToClient(clientInstance,ErrorManager.ACCESS_DENIED);
						}
					}
				}
				else if (session != null && session.equalsIgnoreCase(MetaData.UNBAN_USER)){
					if (message != null){
						String freedIP = message;
						if (currentUser.getUsername().equals(ServerConfig.getInstance().getAdminAccount())){
							if (BanManagement.getInstance().removeBan(message,false)){
								ServerLogger.sendConsoleDebugMessage("Unbanning username: " + message, this.getClass(), 5);
								MetaData unbanOK = new MetaData(MetaData.FROM_SERVER, MetaData.CHATROOM, MetaData.NO_SESSION_NAME);
								MessageAdapter.sendData(null, clientInstance, unbanOK, "Username " + message + " has been unbanned");
							}
							else {
								ErrorManager.sendErrorToClient(clientInstance, ErrorManager.USER_NOT_FOUND);
							}
						}
						else{
							ErrorManager.sendErrorToClient(clientInstance,ErrorManager.ACCESS_DENIED);
						}
					}
				}
				else if (session !=  null && session.equalsIgnoreCase(MetaData.PROXY_CHECK)){
					Socket clientSock = (Socket)ServerCacheHandler.userSocketCache.get(recipient);
					if (message != null && message.equalsIgnoreCase("NULL")){
						MetaData requestProxyCheckHeader = new MetaData(MetaData.FROM_SERVER, MetaData.GENERIC, MetaData.PROXY_CHECK);
						MessageAdapter.sendData(null,clientSock,requestProxyCheckHeader,"NULL");
					}
//					else if (message != null){
//						if (clientSock != null){
//							if (!checkProxyPortOpen(clientSock, message)){
//								MetaData proxyFailed = new MetaData(MetaData.FROM_SERVER, MetaData.GENERIC, MetaData.PROXY_CHECK);
//								MessageAdapter.sendData(null, clientSock,proxyFailed,MetaData.PROXY_FAIL);
//								ServerCacheHandler.userProxyPortState.put(recipient,new Boolean(false));
//							}
//							else {
//								MetaData proxyPassed = new MetaData(MetaData.FROM_SERVER, MetaData.GENERIC, MetaData.PROXY_CHECK);
//								MessageAdapter.sendData(null, clientSock,proxyPassed,MetaData.PROXY_SUCCESS);
//								ServerCacheHandler.userProxyPortState.put(recipient,new Boolean(true));
//							}
//						}
//					}
				}
			}
			
			else if (context != null && context.equalsIgnoreCase(MetaData.DASHBOARD + "")){
				if (session != null && session.equalsIgnoreCase(MetaData.GET_NUM_USERS)){
					MetaData sendUsersHeader = new MetaData(MetaData.FROM_SERVER,MetaData.DASHBOARD,MetaData.GET_NUM_USERS);
					MessageAdapter.sendData(null,clientInstance,sendUsersHeader,ServerCacheHandler.userSocketCache.size()+"");
				}
				
				else if (session != null && session.equalsIgnoreCase(MetaData.GET_NUM_GAMEROOMS)){
					MetaData sendUsersHeader = new MetaData(MetaData.FROM_SERVER,MetaData.DASHBOARD,MetaData.GET_NUM_GAMEROOMS);
					MessageAdapter.sendData(null,clientInstance,sendUsersHeader,ServerCacheHandler.gameroomNameCache.size() + "");
				}
			}
			
			else if (context != null && context.equalsIgnoreCase(MetaData.CHATROOM + "")){
				if (session != null) {
					// Session can be a username or chatroom in this case
					if (ServerCacheHandler.userSocketCache.containsKey(session)){ 
						/* Chat to user */ 
						sendChatMessageToUser(MessageAdapter.getMetaDataFromString(dataIn)
								, session, message);
					}
					else if (ServerCacheHandler.chatroomNameCache.containsKey(session)){
						// Check Access rights 
						// Send to all chatroom clients with Message
						//MessageAdapter.sendToChatroom(MessageAdapter.getMetaDataFromString(dataIn),session,message);
						Chatroom chatroom = (Chatroom)ServerCacheHandler.chatroomNameCache.get(session);
						sendChatMessage(MessageAdapter.getMetaDataFromString(dataIn), chatroom, message);
					}
				}
			}
			else if (context != null && context.equalsIgnoreCase(MetaData.FRIENDSLIST + "")){
				String friendsListUser = currentUser.getUsername();
				if (session != null && session.equalsIgnoreCase(FriendsList.SEND_FRIENDSLIST)){
					FriendsListManager.getInstance().sendWholeFriendsList(friendsListUser);
				}
				//TODO: ADD and DELETE commands here
				
				else if (session != null && session.equalsIgnoreCase("ADD_FRIEND")){
					if (message != null)
						FriendsListManager.getInstance().addUsertoFriendsList(friendsListUser,message);
				}
				else if (session != null && session.equalsIgnoreCase("REMOVE_FRIEND")){
					if (message != null)
						FriendsListManager.getInstance().removeUserFromFriendsList(friendsListUser,message);
				}
			}
			else if (context != null && context.equalsIgnoreCase(MetaData.GAME + "")){
				if (session != null){
					if (session.equalsIgnoreCase(MetaData.SEND_LIST)){
						GameroomManager.getInstance().sendAllGamesToUser(clientInstance);
					}
					else if (session.equalsIgnoreCase(MetaData.JOIN_CHATROOM)){
						//if (ServerCacheHandler.userProxyPortState.get(recipient).equals(new Boolean(true))){
							if (ServerCacheHandler.gameroomNameCache.containsKey(message)){
								GameroomManager.getInstance().joinGameroom(recipient, message);
							}
						//}
//						else {
//							ErrorManager.sendErrorToClient(clientInstance, ErrorManager.GAMEROOM_DENIED);
//						}
					}
					else if (session.equalsIgnoreCase(MetaData.PART_CHATROOM)){
						if (ServerCacheHandler.gameroomNameCache.containsKey(message)){
							GameroomManager.getInstance().leaveGameroom(recipient, message);
						}
					}
					else if (session.equalsIgnoreCase(MetaData.IS_HOST)){
						if (ServerCacheHandler.userGameroomCache.containsKey(recipient)){
							if (ServerCacheHandler.userGameroomCache.get(recipient).equals(message)){
								GameRoom g = (GameRoom)ServerCacheHandler.gameroomNameCache.get(message);
								MetaData whoIsHost = new MetaData(message,MetaData.GAME, MetaData.IS_HOST);
								MessageAdapter.sendData(null,clientInstance, whoIsHost, g.getChatroomCreator());
							}
						}
					}
					else if (session.equalsIgnoreCase(MetaData.START_PROXY)){
						if (ServerCacheHandler.gameroomNameCache.containsKey(message)){
							if (ServerCacheHandler.userGameroomCache.containsKey(recipient)){
								if (((String)ServerCacheHandler.userGameroomCache.get(recipient)).equalsIgnoreCase(message)){
									String inetAddr = new String();
									GameRoom tempGM = (GameRoom)ServerCacheHandler.gameroomNameCache.get(message);
									if (tempGM.getBindIP() != null){
										inetAddr = tempGM.getBindIP();
									} else {
										Socket hostSocket = (Socket)ServerCacheHandler.userSocketCache.get(recipient);
										inetAddr = hostSocket.getInetAddress().getHostAddress();
									}
									MetaData startGameHeader = new MetaData(recipient,MetaData.GAME,MetaData.START_PROXY);
									GameroomManager.getInstance().sendDataToGameroom(message,startGameHeader,inetAddr);
								}
							}
						}
					}
					else if (session.equalsIgnoreCase(MetaData.HOST_READY)){
						if (ServerCacheHandler.gameroomNameCache.containsKey(message)){
							if (((String)ServerCacheHandler.userGameroomCache.get(recipient)).equalsIgnoreCase(message)){
								MetaData startGameHeader = new MetaData(recipient,MetaData.GAME,MetaData.HOST_READY);
								GameroomManager.getInstance().sendDataToGameroom(message,startGameHeader,message);
							}
						}
					}
					else if (session.equalsIgnoreCase(MetaData.STOP_PROXY)){
						if (ServerCacheHandler.gameroomNameCache.containsKey(message)){
							if (((String)ServerCacheHandler.userGameroomCache.get(recipient)).equalsIgnoreCase(message)){
								MetaData startGameHeader = new MetaData(recipient,MetaData.GAME,MetaData.STOP_PROXY);
								GameroomManager.getInstance().sendDataToGameroom(message,startGameHeader,message);
							}
						}
					}
					else if (session.equalsIgnoreCase(MetaData.PROXY_CONNECTED)){
						if (((String)ServerCacheHandler.userGameroomCache.get(recipient)) != null){
							String gameRoomName = (String)ServerCacheHandler.userGameroomCache.get(recipient);
							if (gameRoomName != null){
								MetaData startGameHeader = new MetaData(recipient,MetaData.GAME,MetaData.PROXY_CONNECTED);
								GameroomManager.getInstance().sendDataToGameroom(gameRoomName,startGameHeader,message);
							}
						}
					}
					else if (session.equalsIgnoreCase(MetaData.GAME_STARTED)){
						if (((String)ServerCacheHandler.userGameroomCache.get(recipient)) != null){
							String gameRoomName = (String)ServerCacheHandler.userGameroomCache.get(recipient);
							if (gameRoomName != null){
								MetaData startGameHeader = new MetaData(recipient,MetaData.GAME,MetaData.GAME_STARTED);
								GameroomManager.getInstance().sendDataToGameroom(gameRoomName,startGameHeader,message);
							}
						}
					}
					else if (session.equalsIgnoreCase(MetaData.GAME_STOPPED)){
						if (((String)ServerCacheHandler.userGameroomCache.get(recipient)) != null){
							String gameRoomName = (String)ServerCacheHandler.userGameroomCache.get(recipient);
							if (gameRoomName != null){
								MetaData startGameHeader = new MetaData(recipient,MetaData.GAME,MetaData.GAME_STOPPED);
								GameroomManager.getInstance().sendDataToGameroom(gameRoomName,startGameHeader,message);
							}
						}
					}
					else { // Assume its a chat message
						if (ServerCacheHandler.gameroomNameCache.containsKey(session)){
							MetaData chatHeader = new MetaData(recipient,Integer.valueOf(context).intValue(),session);							
							GameroomManager.getInstance().sendDataToGameroom(session,chatHeader,message);
						}
					}
				}
			}
		}
		
	}

	public void sendInitialChatroomUserList(Chatroom joinedRoom, User currentUser) throws IOException {
		MetaData sendListHeader = new MetaData(joinedRoom.getChatroomName(),MetaData.CHATROOM, MetaData.SEND_LIST);
		Vector usersInChatroom = new Vector(joinedRoom.getListOfUsers());
		
		if (usersInChatroom.isEmpty())
			return;
		
		for (int i = 0; i < usersInChatroom.size(); i++){
			String userOnList = usersInChatroom.elementAt(i).toString();
			MessageAdapter.sendData(null, clientInstance, sendListHeader, userOnList);
		}
	}
	
	private void announceUserJoin(Chatroom joinedRoom, User currentUser) throws IOException {
		MetaData announceListHeader = new MetaData(joinedRoom.getChatroomName(), MetaData.CHATROOM, MetaData.JOIN_CHATROOM);
		Vector usersInChatroom = new Vector(joinedRoom.getListOfUsers());
		
		if (usersInChatroom.isEmpty())
			return;
		
		for (int i = 0; i < usersInChatroom.size(); i++){
			String userOnList = usersInChatroom.elementAt(i).toString();
			Socket chatroomUserSocket = (Socket)ServerCacheHandler.userSocketCache.get(userOnList);
			if (chatroomUserSocket == null){
				ServerLogger.sendConsoleDebugMessage("Socket broken for user " 
						+ userOnList + ". Recommended action: kill the user", this.getClass());
				continue;
			}
			MessageAdapter.sendData(null, chatroomUserSocket, announceListHeader, currentUser.getUsername());
		}
	}
	
	private void announceUserPart(Chatroom joinedRoom, User currentUser) throws IOException {
		MetaData announceListHeader = new MetaData(joinedRoom.getChatroomName(), MetaData.CHATROOM, MetaData.PART_CHATROOM);
		Vector usersInChatroom = new Vector(joinedRoom.getListOfUsers());
		
		if (usersInChatroom.isEmpty())
			return;
		
		for (int i = 0; i < usersInChatroom.size(); i++){
			String userOnList = usersInChatroom.elementAt(i).toString();
			Socket chatroomUserSocket = (Socket)ServerCacheHandler.userSocketCache.get(userOnList);
			if (chatroomUserSocket == null){
				ServerLogger.sendConsoleDebugMessage("Socket broken for user " 
						+ userOnList + ". Recommended action: kill the user", this.getClass());
				continue;
			}
			MessageAdapter.sendData(null, chatroomUserSocket, announceListHeader, currentUser.getUsername());
		}
	}
	
	private void sendChatMessage(MetaData chatListHeader, Chatroom chatroom, String message) throws IOException {
		Vector usersInChatroom = new Vector(chatroom.getListOfUsers());
		
		if (usersInChatroom.isEmpty()){
			return;
		}
		
		for (int i = 0; i < usersInChatroom.size(); i++){
			String userOnList = usersInChatroom.elementAt(i).toString();
			Socket chatroomUserSocket = (Socket)ServerCacheHandler.userSocketCache.get(userOnList);
			if (chatroomUserSocket == null){
				ServerLogger.sendConsoleDebugMessage("Socket broken for user " 
						+ userOnList + ". Recommended action: kill the user", this.getClass());
				continue;
			}
			MessageAdapter.sendData(null, chatroomUserSocket, chatListHeader, message);
		}	
	}
	
	private void sendChatMessageToUser(MetaData IMHeader, String userName, String message) throws IOException{
		// Treat IM almost like a chatroom by using chatroom function
		// Make an empty blank chatroom and add the user
		String currentUser = (String)ServerCacheHandler.socketUserCache.get(clientInstance);
		
		Chatroom IMSession = new Chatroom(new User(currentUser),null);
		IMSession.addUserToChatroom(userName);
		//IMSession.addUserToChatroom(currentUser);
		
		sendChatMessage(IMHeader, IMSession, message);
	}
	
	private void welcomeUserToChatroom(String chatroom) throws IOException{
		MetaData welcomeHeader = new MetaData(chatroom, MetaData.CHATROOM, MetaData.GREET);
		MessageAdapter.sendData(null, clientInstance, welcomeHeader, chatroom);
	}
	
	private void sendUptimeRequest(String requestedUser) throws IOException{
		Long requestedUptime;
		MetaData uptimeResponse;
		Date d = new Date();
		if (requestedUser != null){
			uptimeResponse = new MetaData(requestedUser, MetaData.GENERIC, MetaData.UPTIME);
			if (requestedUser.equalsIgnoreCase(MetaData.SYSTEM_VAR)){
				requestedUptime = new Long(d.getTime() - ((Long)ServerCacheHandler.userUptimeCache.get(MetaData.SYSTEM_VAR)).longValue());
			}
			else {
				if (!DSChatServer.isUserOnline(requestedUser)){
					MessageAdapter.sendData(null, clientInstance, uptimeResponse, "OFFLINE");
					return;
				}
				requestedUptime = new Long(d.getTime() - ((Long)ServerCacheHandler.userUptimeCache.get(requestedUser)).longValue());				
			}
			MessageAdapter.sendData(null, clientInstance,uptimeResponse,requestedUptime.longValue() + "");
		}
	}
	
	private void sendChatroomListings () throws IOException {
		Enumeration chatroomList;
		chatroomList = ServerCacheHandler.chatroomNameCache.keys();
		
		while (chatroomList.hasMoreElements()){
			String chatroomString = new String();
			int chatroomUsersNumber;
			chatroomString = (String)chatroomList.nextElement();
			chatroomUsersNumber = ((Chatroom)ServerCacheHandler.chatroomNameCache.get(chatroomString)).getListOfUsers().size();
			
			MetaData chatListHeader = new MetaData(MetaData.FROM_SERVER, MetaData.GENERIC, MetaData.SEND_CHATROOM_LIST);
			MessageAdapter.sendData(null,clientInstance,chatListHeader, chatroomString + ":" + chatroomUsersNumber);
		}
	}
	
	private void checkUserLimit(String userName) throws SocketException{
		int offsetLimit = 5000;
		long offset;
		Long timeNow = new Long(0);
		Long lastTime = new Long(0);
		Date d = new Date();
		
		if (ServerCacheHandler.userLimitCache.containsKey(userName)){
			lastTime = (Long)ServerCacheHandler.userLimitCache.get(userName);
			timeNow = new Long(d.getTime());
			offset = timeNow.longValue() - lastTime.longValue();
			
			if (offset <= offsetLimit)
				throw new SocketException();
		}
		ServerCacheHandler.userLimitCache.put(userName,new Long(d.getTime()));
	}
}
