/*
 * Created on May 30, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.GTADS.usermanager;

import java.net.*;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Date;
import java.util.Hashtable;
import java.io.*;

import org.GTADS.server.*;
import org.GTADS.messenger.*;
import org.GTADS.protocol.*;
import org.GTADS.client.ClientConnectionHandler;
import org.GTADS.debug.*;
import org.GTADS.helper.*;

/**
 * @author Administrator
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class AuthenticationManager {
	public static String AUTHENTICATION_FLAG = "AUTHENTICATE";
	public static int LOGIN_FAILED = 0;
	public static int LOGIN_SUCCESS = 1;
	public static int LOGIN_NEW = 2;
	public static int MAXED_OUT = 3;
	public static int NEW_USER_SUCCESS = 4;
	public static int NEW_USER_DISABLED = 5;
	public static int NEW_USER_FAIL = 6;
	public static int USER_BANNED = 7;
	
	public static int requestAuthentication(Socket clientLogin, DSChatServer thisServer) throws IOException, EOFException{
		try {
			String dateKey = (new Date()).getTime() + "";
			DataOutputStream dout = (DataOutputStream)ServerCacheHandler.socketStreamCache.get(clientLogin);
			DataInputStream din = new DataInputStream(clientLogin.getInputStream());
			MessageAdapter.sendData(null, clientLogin, 
					new MetaData(MetaData.FROM_SERVER, MetaData.GENERIC,MetaData.LOGIN_SESSION), AUTHENTICATION_FLAG + "," + dateKey);
			
			String incomingAuth = din.readUTF();
			return validateClientAuth(incomingAuth, clientLogin, thisServer, dateKey);
		} catch (Exception E) {
			return LOGIN_FAILED;
		}
	}
	
	public static void readInPasswords(){
		try {
			FileReader authFile = new FileReader(ServerConfig.getInstance().getPasswdFileName());
			BufferedReader inputBuffer = new BufferedReader(authFile);
			boolean endOfFile = false;
			String acctUserPass[] = new String[2];
			String acctLine = new String();
			Hashtable temporaryAccountHash = new Hashtable();
			
			if (ServerConfig.getInstance().getIsPHPBBAccounts() ||
					ServerConfig.getInstance().getIsDBAccounts()){
				temporaryAccountHash = refreshAccountsFromSQL();
			}
			else {
				while (!endOfFile) {
					acctLine = inputBuffer.readLine();
					if (acctLine == null)
						endOfFile = true;
					else {
						acctUserPass = acctLine.split(",");
						if (acctUserPass.length > 1){
							temporaryAccountHash.put(acctUserPass[0], acctUserPass[1]);
							//ServerCacheHandler.userPasswordCache.put(acctUserPass[0], acctUserPass[1]);
						}
					}
				}
			}
			
			if (temporaryAccountHash == null)
				temporaryAccountHash = new Hashtable();
			ServerLogger.sendConsoleOutput("Read in " + temporaryAccountHash.size() + " accounts", AuthenticationManager.class);
			ServerCacheHandler.userPasswordCache = (Hashtable)temporaryAccountHash.clone();
			
		} catch (FileNotFoundException F) {
			ServerLogger.sendConsoleOutput("Accounts file " + ServerConfig.getInstance().getPasswdFileName() +
					" Not Found...", AuthenticationManager.class);
			ServerLogger.sendConsoleOutput("!!!Halt server immediately and address problem!!!", AuthenticationManager.class);
		} catch (IOException e) {
			ServerLogger.sendConsoleOutput("!!!Error reading accounts file!!!", AuthenticationManager.class);
		}
	}
	
	public static Hashtable refreshAccountsFromSQL(){
		Hashtable tempHashtable = new Hashtable();
		try {
		//			Register the JDBC driver for MySQL.
		Class.forName("com.mysql.jdbc.Driver");
		Statement stmt;
		ResultSet rs;
		String dbHostname = ServerConfig.getInstance().getPHPBBDBHostName();
		String dbName = ServerConfig.getInstance().getPHPDBName();
		String dbTable = ServerConfig.getInstance().getPHPBBDBTable();
		String dbUserField = ServerConfig.getInstance().getPHPBBUserField();
		String dbPassField = ServerConfig.getInstance().getPHPBBPasswordField();
		int dbPort = ServerConfig.getInstance().getPHPBBDBPort();
		String dbuser = ServerConfig.getInstance().getPHPBBDBUsername();
		String dbpass = ServerConfig.getInstance().getPHPBBDBPassword();
		
		
		if (ServerConfig.getInstance().getIsDBAccounts()){
			dbHostname = ServerConfig.getInstance().getDBHostname();
			dbName = ServerConfig.getInstance().getDBAccountsDBName();
			dbTable = ServerConfig.getInstance().getDBAccountsTable();
			dbUserField = "username";
			dbPassField = "password";
			dbuser = ServerConfig.getInstance().getDBAccountsUsername();
			dbPort = ServerConfig.getInstance().getDBPort();
			dbpass = ServerConfig.getInstance().getDBAccountsPassword();
		}
		
		String dbUrl = "jdbc:mysql://" + dbHostname +  ":"+ dbPort + "/" + dbName;
		Connection con = DriverManager.getConnection(dbUrl,dbuser, dbpass);
		
		//Get a Statement object
		stmt = con.createStatement();
		
		rs = stmt.executeQuery("SELECT " + dbUserField + "," + dbPassField +
				" FROM " + dbTable);

		while (rs.next()){
			tempHashtable.put(rs.getString(dbUserField), rs.getString(dbPassField));
		}
	      
		} catch (ClassNotFoundException cnf){
			cnf.printStackTrace();
			return null;
		} catch (SQLException se){
			se.printStackTrace();
		}
		return tempHashtable;
	}
	
	public static int validateClientAuth(String authLine, Socket clientLogin, DSChatServer thisServer, String dateKey) {
		String messageLine[] = new String[4];
		String userName;
		String passWord;
		int amountOfFields;
		
		if (BanManagement.getInstance().checkIP(clientLogin.getInetAddress().getHostAddress())){
			return USER_BANNED;
		}
		
		if (authLine != null){
			authLine = Helper.clipCarriageReturn(authLine);
			messageLine = authLine.split(",");
			amountOfFields = messageLine.length;
			
			if (amountOfFields == 4) {
				userName = messageLine[0];
				passWord = messageLine[3];	
			} else
				return LOGIN_FAILED;
			
			if (BanManagement.getInstance().checkUser(userName)){
				return USER_BANNED;
			}
			
			if (userName != null && passWord != null){
				if (userName.equalsIgnoreCase(MetaData.NEW_USER_ACCT)){
					try {
						if (ServerConfig.getInstance().clientSignupEnabled()){
							return createNewUserAccount(clientLogin);
						}
						else {
							return NEW_USER_DISABLED;
						}
					} catch (IOException ioe){
						return NEW_USER_FAIL;
					}
				}
				if (((String)ServerCacheHandler.userPasswordCache.get(userName)) != null && 
						Helper.getMD5Hash(dateKey + (String)ServerCacheHandler.userPasswordCache.get(userName)).equals(passWord)){
					// Check if login goes over the max allowed clients
					// Also check if the user will bump a dup login off
					// or if user is super user.
					if (ServerConfig.getInstance().getMaxClients() != 0) {
						if (ServerCacheHandler.userSocketCache.size() >= ServerConfig.getInstance().getMaxClients()){
							if (!userName.equalsIgnoreCase(ServerConfig.getInstance().getAdminAccount()) &&
									ServerCacheHandler.userSocketCache.get(userName) == null){
								return MAXED_OUT;
							}
						}
					}
					// If cache exists this means the user is already logged in
					// or the socket is still alive
					// We should check if it exists and kill it if it exists.
					
					if (ServerCacheHandler.userSocketCache.get(userName) != null){
						// TODO: Add a kill connection function outside of DSChatServer
						DSChatServer.getInstance().killConnection((Socket)ServerCacheHandler.userSocketCache.get(userName)
								, thisServer);
						DSChatServer.getInstance().addConnected();
					}
					ServerCacheHandler.setUserSocketCache(userName,clientLogin);
					return LOGIN_SUCCESS;
				}
			}
		}
		return LOGIN_FAILED;
	}
	
	public static int loginClient(Socket clientSocket, String username, String password) throws IOException{
		try {
		DataInputStream din = new DataInputStream(clientSocket.getInputStream());
		String incomingString = new String();
		String authenticationString = new String("SERVER,0,LOGIN,AUTHENTICATE" + ProtocolHandler.carriageReturn);
		String newUserOkString = new String("SERVER,0," + MetaData.NEW_USER_ACCT + ",PROCEED" + ProtocolHandler.carriageReturn);
		String loginStatus = new String("SERVER,0,LOGIN,");
		String newUserDisabledString = new String ("SERVER,0," + MetaData.NEW_USER_ACCT + ",DISABLED");
		
			incomingString = din.readUTF();
			if (incomingString != null && incomingString.split(",").length >= 4){
				String[] incomingSplit = incomingString.split(",");
				if (incomingSplit[0].equalsIgnoreCase(MetaData.FROM_SERVER) &&
						incomingSplit[1].equalsIgnoreCase(MetaData.GENERIC + "") &&
						incomingSplit[2].equalsIgnoreCase(MetaData.LOGIN_SESSION) &&
						Helper.clipCarriageReturn(incomingSplit[3]).equalsIgnoreCase(AUTHENTICATION_FLAG)){
					String md5ChallengePassword;
					// We want to ensure a small level of backward compatibility
					// If the auth string has 5 arguments then we will proceed with the
					// md5 encryption method or else we will revert to plaintext
					if (incomingSplit.length == 5){
						String challenge = Helper.clipCarriageReturn(incomingSplit[4]);
						md5ChallengePassword = Helper.getMD5Hash(challenge + Helper.getMD5Hash(password));
					}
					else {
						md5ChallengePassword = password;
					}
					/*System.out.println("DateKey = " + challenge);
					System.out.println("md5Password = " + Helper.getMD5Hash(password));
					System.out.println("combined key + challenge = " + md5ChallegePassword);*/
					if (!ClientConnectionHandler.isNewAcct){
						MessageAdapter.sendData(null, clientSocket, new MetaData(username,MetaData.GENERIC, MetaData.LOGIN_SESSION), md5ChallengePassword);
						
						Thread.sleep(0);
						incomingString = din.readUTF();
						if (incomingString != null && incomingString.equalsIgnoreCase(loginStatus + ProtocolHandler.LOGIN_SUCCESS + ProtocolHandler.carriageReturn))
							return LOGIN_SUCCESS;
						else if (incomingString != null && incomingString.equalsIgnoreCase(loginStatus + ProtocolHandler.MAXED_USERS + ProtocolHandler.carriageReturn))
							return MAXED_OUT;
						else if (incomingString != null && incomingString.equalsIgnoreCase(loginStatus + MetaData.USER_BANNED + ProtocolHandler.carriageReturn)){
							return USER_BANNED;
						}	
					}
					else {
						ClientConnectionHandler.isNewAcct = false;
						MetaData newUserHeader = new MetaData(MetaData.NEW_USER_ACCT,MetaData.GENERIC, MetaData.LOGIN_SESSION);
						MessageAdapter.sendData(null, clientSocket, newUserHeader, Helper.getMD5Hash(password));
						incomingString = din.readUTF();
						
						if (incomingString != null && incomingString.equalsIgnoreCase(newUserOkString)){
							newUserHeader = new MetaData(username,MetaData.GENERIC, MetaData.LOGIN_SESSION);
							MessageAdapter.sendData(null, clientSocket, newUserHeader, Helper.getMD5Hash(password));
							
							incomingString = din.readUTF();
							if (incomingString != null && incomingString.equalsIgnoreCase(loginStatus + ProtocolHandler.LOGIN_SUCCESS + ProtocolHandler.carriageReturn)){
								return NEW_USER_SUCCESS;
							}
						}
						else if (incomingString != null && incomingString.equalsIgnoreCase(newUserDisabledString + ProtocolHandler.carriageReturn)){
							return NEW_USER_DISABLED;
						}
					}
					
				}
			}
/*			if (incomingString != null && incomingString.equalsIgnoreCase(authenticationString)
					&& !ClientConnectionHandler.isNewAcct){
				MessageAdapter.sendData(null, clientSocket, new MetaData(username,MetaData.GENERIC, MetaData.LOGIN_SESSION), password);
				
				Thread.sleep(0);
				incomingString = din.readUTF();
				if (incomingString != null && incomingString.equalsIgnoreCase(loginStatus + ProtocolHandler.LOGIN_SUCCESS + ProtocolHandler.carriageReturn))
					return LOGIN_SUCCESS;
				else if (incomingString != null && incomingString.equalsIgnoreCase(loginStatus + ProtocolHandler.MAXED_USERS + ProtocolHandler.carriageReturn))
					return MAXED_OUT;
				else if (incomingString != null && incomingString.equalsIgnoreCase(loginStatus + MetaData.USER_BANNED + ProtocolHandler.carriageReturn)){
					return USER_BANNED;
				}
			}
			else if (incomingString != null && incomingString.equalsIgnoreCase(authenticationString)){
				ClientConnectionHandler.isNewAcct = false;
				MetaData newUserHeader = new MetaData(MetaData.NEW_USER_ACCT,MetaData.GENERIC, MetaData.LOGIN_SESSION);
				MessageAdapter.sendData(null, clientSocket, newUserHeader, password);
				incomingString = din.readUTF();
				
				if (incomingString != null && incomingString.equalsIgnoreCase(newUserOkString)){
					newUserHeader = new MetaData(username,MetaData.GENERIC, MetaData.LOGIN_SESSION);
					MessageAdapter.sendData(null, clientSocket, newUserHeader, password);
					
					incomingString = din.readUTF();
					if (incomingString != null && incomingString.equalsIgnoreCase(loginStatus + ProtocolHandler.LOGIN_SUCCESS + ProtocolHandler.carriageReturn)){
						return NEW_USER_SUCCESS;
					}
				}
				else if (incomingString != null && incomingString.equalsIgnoreCase(newUserDisabledString + ProtocolHandler.carriageReturn)){
					return NEW_USER_DISABLED;
				}
			}*/
			return LOGIN_FAILED;
		} catch (InterruptedException o) {
			return LOGIN_FAILED;
		}
	}
	
	private static int createNewUserAccount(Socket clientLogin) throws IOException {
		int success = NEW_USER_FAIL;
		DataInputStream din = new DataInputStream(clientLogin.getInputStream());
		MetaData newUserHeader = new MetaData(MetaData.FROM_SERVER, MetaData.GENERIC,
				MetaData.NEW_USER_ACCT);
		MessageAdapter.sendData(null, clientLogin, newUserHeader, "PROCEED");
		// Gives client the go ahead to write new user
		
		String incomingUserLine = din.readUTF();
		if (incomingUserLine != null)
			success = writeUserAccount(incomingUserLine);
		
		return success;
	}
	
	private static int writeUserAccount(String incomingUserLine){
		int success = NEW_USER_FAIL;
		String messageLine[] = new String[4];
		String userName;
		String password;
		
		incomingUserLine = Helper.clipCarriageReturn(incomingUserLine);
		
		messageLine = incomingUserLine.split(",");
		if (messageLine.length == 4){
			userName = messageLine[0];
			password = messageLine[3];
			
			if (!ServerCacheHandler.userPasswordCache.containsKey(userName)){
				// Validate Username
				if (validateCleanText(userName) && validateCleanText(password)){
					if (ServerConfig.getInstance().getIsDBAccounts()){
						if (writeUserPassToDB(userName, password)){
							success = NEW_USER_SUCCESS;
						}
					}
					else {
						if (writeUserPassToFile(userName, password)){
							success = NEW_USER_SUCCESS;
						}
					}
				}
			}
		}
		return success;
	}
	
	public static boolean isAdminAccount(String username){
		boolean isAdmin = false;
		if (username.equals(ServerConfig.getInstance().getAdminAccount())){
			isAdmin = true;
		}
		return isAdmin;
	}
	
	private static boolean writeUserPassToFile(String user, String pass){
		boolean success = false;
		
		String fileName = ServerConfig.getInstance().getPasswdFileName();
		try {
			File accountsFile = new File(fileName);
			
			if (accountsFile.exists()){
				FileWriter accountWriter = new FileWriter(accountsFile, true);
				BufferedWriter buffer = new BufferedWriter(accountWriter);
				
				buffer.newLine();
				buffer.write(user + "," + pass);
				//buffer.newLine();
				buffer.close();
				ServerCacheHandler.userPasswordCache.put(user, pass);
				success = true;
			}
			return success;
		} catch (IOException ioe){
			return success;
		}
	}
	
	private static boolean writeUserPassToDB(String user, String pass){
		boolean success = false;
		String SQLStatement = new String();
		try {
		Class.forName("com.mysql.jdbc.Driver");
		Statement stmt;
		ResultSet rs;
		String dbHostname = ServerConfig.getInstance().getDBHostname();
		String dbName = ServerConfig.getInstance().getDBAccountsDBName();
		String dbTable = ServerConfig.getInstance().getDBAccountsTable();
		String dbUserField = "username";
		String dbPassField = "password";
		String dbuser = ServerConfig.getInstance().getDBAccountsUsername();
		int dbPort = ServerConfig.getInstance().getDBPort();
		String dbpass = ServerConfig.getInstance().getDBAccountsPassword();
		SQLStatement = "INSERT into " + dbTable + " (" + dbUserField + "," + dbPassField + ")" +
		" VALUES " + " ( '" + user + "'," + "'" + pass + "' )";
		
		String dbUrl = "jdbc:mysql://" + dbHostname +  ":"+ dbPort + "/" + dbName;
		Connection con = DriverManager.getConnection(dbUrl,dbuser, dbpass);
		
		//Get a Statement object
		stmt = con.createStatement();
		
		int insertDone = stmt.executeUpdate(SQLStatement);
		if (insertDone == 1){
			ServerCacheHandler.userPasswordCache.put(user, pass);
			success = true;
		}
		} catch (ClassNotFoundException cnf){
			return success;
		}
		catch (SQLException se){
			se.printStackTrace();
			ServerLogger.sendConsoleDebugMessage("Error on " + SQLStatement, AuthenticationManager.class);
		}
		
		return success;
	}
	
	private static boolean validateCleanText(String text){
		for (int i = 1; i < text.length(); i++){
			if (!(text.charAt(i) >= 'a' && text.charAt(i) <= 'z' ||
					text.charAt(i) >= 'A' && text.charAt(i) <= 'Z' ||
					text.charAt(i) >= '0' && text.charAt(i) <= '9' ||
					text.charAt(i) == '_')){
						return false;
					}
		}
		return true;
	}
}
